﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.7
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private B4XTable1 As B4XTable
	
	Private xui As XUI
	Private CS As CSBuilder
	Type StudentData (Studentnamed As String, LblCity As String,Classr As String, Stream As String, Subject As String, Termr As String,City As String, Latitude As Float, Longitude As Float, Altitude As String,Totalmarks As String,English As String,Maths As String,Science As String,Sst As String,ire As String,Lit1 As String,Lit2 As String,Totalgrade As String,Division As String,iregrade As String,sciencegrade As String,sstgrade As String,mathsgrade As String,engrade As String)
	Private StudentCount As Int
	Private Limit As Int = 2000
	'Private Panel1 As B4XView
	Private TxtSearchFilter As B4XView
	Private showpastrecords As CustomListView
	Private Studentnamed, Classr, Stream, LblCity,English, Maths, Science, Sst, Totalgrade,Totalmarks,Termr,Division,ire,iregrade,sciencegrade,sstgrade,engrade,mathsgrade,Lscience,Lsst,label11 As B4XView
	Dim LblName ,Label9 As Label
	Dim archivesummary As ArchivePrimary
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("archivedresults")
	archivesummary.Initialize
	B4XPages.AddPage("Archiveprimary", archivesummary) 'Add first page

	TxtSearchFilter_TextChanged("", "")
'	Sleep(0)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub ShowPastrecords_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim ExtraSize As Int = 25 'List size
	For i = Max(0, FirstIndex - ExtraSize) To Min(LastIndex + ExtraSize, showpastrecords.Size - 1)
		Dim Pnl As B4XView = showpastrecords.GetPanel(i)
		If i > FirstIndex - ExtraSize And i < LastIndex + ExtraSize Then
			If Pnl.NumberOfViews = 0 Then 'Add each item/layout to the list/main layout
				Dim AD As StudentData = showpastrecords.GetValue(i)
				Pnl.LoadLayout("Studentinfo2")
			'Root.LoadLayout("Studentinfo2")
				Dim kclass As String
				Classr.Text = AD.Classr
				kclass= AD.Classr
				Log(kclass)
			
				Log( AD.Termr)
				
				Stream.Text = AD.Stream
				LblName.Text = AD.Termr
				Label9.Text= AD.Subject
				'LblICAO.Text = AD.ICAO
				LblCity.Text = AD.Studentnamed
				Totalmarks.Text = AD.Totalmarks
				English.Text= AD.English
				Maths.Text=AD.Maths
				Totalgrade.Text=AD.Totalgrade
				If kclass="P1" Then
					Lsst.Text="LIT1:"
					Lscience.Text="LIT2:"
						
				End If
				
				If kclass="P2" Then
					Lsst.Text="LIT1:"
					Lscience.Text="LIT2:"
						
				End If
			
				If kclass="P3" Then
					Lsst.Text="LIT1:"
					Lscience.Text="LIT2:"
						
				End If
				Sst.Text=AD.Sst
				Science.Text=AD.Science
				 
				 
				Division.Text=AD.Division
				ire.Text=AD.ire
				'label12.Text="SUL"
				iregrade.Text=AD.iregrade
				sciencegrade.Text=AD.sciencegrade
				sstgrade.Text=AD.sstgrade
				mathsgrade.Text=AD.mathsgrade
				engrade.Text=AD.engrade
				'	Log(AD.Totalgrade)
				' English.Text=AD.en
				'LblLongitude.Text = AD.Longitude

			
			End If
		Else 'Not visible
			If Pnl.NumberOfViews > 0 Then
				Pnl.RemoveAllViews 'Remove none visable item/layouts from the list/main layout
			End If
		End If
	Next
End Sub

Sub TxtSearchFilter_TextChanged (Old As String, New As String)
	If New.Length = 1 Or TxtSearchFilter.Text.Length = 2 Then Return
	showpastrecords.Clear
	Sleep(0)

	Dim SenderFilter As Object
	If New.Length = 0  Then
		StudentCount = B4XPages.MainPage.SQL.ExecQuerySingleResult("SELECT COUNT(*) FROM `Academicspastv2`;") 'The amuont of airports listed in the database
		SenderFilter = B4XPages.MainPage.SQL.ExecQueryAsync("SQL", $"SELECT * FROM `Academicspastv2` ORDER BY `Names` ASC LIMIT ${Limit};"$, Null) 'I NO NOT RECOMMEND that you load the whole database
	Else
		StudentCount = 0
		SenderFilter = B4XPages.MainPage.SQL.ExecQueryAsync("SQL", $"SELECT * FROM `Academicspastv2` WHERE `Years` Like '%${New}%' ORDER BY `Years` ASC LIMIT 500;"$, Null) 'Limited for slower devices
	End If

	Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, rs As ResultSet)
	If Success Then
		Dim StartTime As Long = DateTime.Now
		Do While rs.NextRow
			Dim AD As StudentData
			AD.Initialize
			AD.Studentnamed	= rs.GetString("Names")
			AD.Classr = rs.GetString("Class")
			AD.Stream	= rs.GetString("Stream")
			AD.Termr = rs.GetString("Expressed")
			'AD.Subject= rs.GetString("Class")
			AD.Totalmarks= rs.GetString("Totalscore")
			AD.Totalgrade= rs.GetString("Totalgrade")
			AD.English= rs.GetString("engscore")
			AD.engrade= rs.GetString("engrade")
			AD.Maths= rs.GetString("mathsscore")
			AD.mathsgrade= rs.GetString("mathsgrade")
			AD.Sst= rs.GetString("sstscore")
			AD.Science= rs.GetString("sciencescore")
			AD.Division= rs.GetString("Division")
			AD.ire= rs.GetString("ire")
			AD.iregrade= rs.GetString("iregrade")
			AD.sciencegrade=rs.GetString("sciencegrade")
			AD.sstgrade=rs.GetString("sstgrade")
		
			Dim Pnl As B4XView = xui.CreatePanel("")
			Pnl.SetLayoutAnimated(0, 0, 0, showpastrecords.AsView.Width, 190dip) 'Panel height + 4 for drop shadow
			showpastrecords.Add(Pnl, AD)
		Loop
		rs.Close
		
		Log($"List population time = ${NumberFormat2((DateTime.Now - StartTime) / 1000, 1, 2, 2, False)} seconds to populate ${showpastrecords.Size} Student names"$)
	Else
		Log(LastException)
	End If
	
	'Add an icon to the activity text by using CSBuilder
	If StudentCount = 0 Then
			B4XPages.SetTitle(Me, CS.Initialize.Typeface(Typeface.FONTAWESOME).Append(Chr(0xF19D)).Append($" ${showpastrecords.Size} Records"$).PopAll) 'Page title
	Else
		B4XPages.SetTitle(Me,CS.Initialize.Typeface(Typeface.FONTAWESOME).Append(Chr(0xF19D)).Append($" Loaded ${Limit} Pastrecords Loaded from ${StudentCount}"$).PopAll)
	
	End If
End Sub

Sub B4XPage_close
	'B4XPages.ClosePage(Me)
'	B4XPages.ShowPageAndRemovePreviousPages("AcademicExtract")
End Sub

Private Sub B4XPage_Appear
	
End Sub
