﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.6
@EndOfDesignText@
Sub Class_Globals
	'Public B4XLoading As B4XLoadingIndicator
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	InitializeDB
End Sub


'SELF EXPLANATORY
Sub InitializeDB
	Dim jo As JavaObject
	jo.InitializeStatic("java.util.Locale").RunMethod("setDefault", Array(jo.GetField("UK")))
	
#If B4A
'	File.Delete(File.DirInternal, "studentdbmk.sql")
	If Not(B4XPages.MainPage.SQL.IsInitialized) Then
		B4XPages.MainPage.SQL.Initialize(File.DirInternal, "studentdbmk.sql", True) 'Connect to the database
		'SQLInit  '
	End If
	SQLInit  'mahares
	Log($"Database size = ${File.Size(File.DirInternal, "studentdbmk.sql")}"$) 'View the size of the file in the logs.
#Else If B4i
	'File.Delete(File.DirTemp, "world_population.db")
	If Not(File.Exists(File.DirTemp, "world_population.db")) Then 'Does the database exists
		Wait For (File.CopyAsync(File.DirAssets, "world_population.db", File.DirTemp, "world_population.db")) Complete (Success As Boolean) 'Copy the database to another folder
		Log($"Database copied = ${Success}"$)
	End If

	Log($"Database size = ${File.Size(File.DirTemp, "world_population.db")}"$) 'View the size of the file in the logs.
	B4XPages.MainPage.SQL.Initialize(File.DirTemp, "world_population.db", True) 'Connect to the database
#Else If B4J
	'File.Delete(File.DirTemp, "world_population.db")
	If Not(File.Exists(File.DirTemp, "world_population.db")) Then 'Does the database exists
		Wait For (File.CopyAsync(File.DirAssets, "world_population.db", File.DirTemp, "world_population.db")) Complete (Success As Boolean) 'Copy the database to another folder
		Log($"Database copied = ${Success}"$)
	End If

	Log($"Database size = ${File.Size(File.DirTemp, "world_population.db")}"$) 'View the size of the file in the logs.
	B4XPages.MainPage.SQL.InitializeSQLite(File.DirTemp, "world_population.db", True) 'Connect to the database
#End If

	Sleep(0) 'Needed to update the UI
	'B4XPages.MainPage.B4XLoading.Hide 'Hide the loading spinner
	'B4XPages.MainPage.PanBacking.Visible = True 'Show globe and flag panel
End Sub


Sub SQLInit
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Register")  'you can comment/uncomment for testing
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS tbl_Messages")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Academicspastv2")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Academicspastcurvev2")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Alevelreport")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Anouncements")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS AcademicsLoadCurve")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS AcademicsLoadCurveP1P2")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS AcademicsLoadCompare")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS AcademicsLoadCurvePast")
	
	
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Academicspast")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Classes")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Years")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Terms")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Sentmessages")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Recievedsms")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS SMSlist")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Student")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS  Eventsinfo ")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Academics")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Allacounts")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Balances")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Statement")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Balances2")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Studentphoto")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Studentphoto2")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Subjects")
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Homework")
	Private query As String
	'Subjects
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Subjects")
	query = "CREATE TABLE IF NOT EXISTS   Subjects (Subject Text, ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('English', '1')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('Literacy1', '2')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('Literacy2', '3')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('Mathematics', '4')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('Science', '5')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('Sst', '6')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Subjects VALUES ('RE', '7')"
	
	'SECONDARY
	
	B4XPages.MainPage.SQL.ExecNonQuery("DROP TABLE IF EXISTS Classes")
	query = "CREATE TABLE IF NOT EXISTS   Classes (Class Text, ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S1', '1')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S2', '2')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S3', '3')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S4', '4')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S5', '5')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S6', '6')"
	'PRIMARY
	query = "INSERT INTO Classes VALUES ('PRE', '11')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)

	query = "INSERT INTO Classes VALUES ('APP NOTE', '19')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "INSERT INTO Classes VALUES ('CIRCULAR', '20')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "INSERT INTO Classes VALUES ('P1', '12')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P2', 13)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P3', '14')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P4', '15')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P5', '16')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P6', '17')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P7', '18')"
	B4XPages.MainPage.SQL.ExecNonQuery(query)

	query = "CREATE TABLE IF NOT EXISTS   Homework (Class Text,Status Text,Category Text, ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Studentphoto2 (name TEXT, image BLOB,Account TEXT)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Anouncements (anounce TEXT,Account TEXT,ID INTEGER)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "CREATE TABLE IF NOT EXISTS   SMSlist (Account Text, Names Text,Phone text,Sex text,ID INTEGER,Phone2 text )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Years (Years Text,ID INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Terms (Term Text,Account Text,ID INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Alevelreport (Account Text, Points Text,Name text,Subject text, ID INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)

	query = "CREATE TABLE IF NOT EXISTS   Sentmessages (Datesent Text, Sms text,ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   tbl_Messages (Id INTEGER PRIMARY KEY, Timestamp Integer, ChatClientName TEXT,  Message TEXT, IOflag TEXT,INflag TEXT,Phone TEXT)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)	
			
	query = "CREATE TABLE IF NOT EXISTS   Recievedsms (Daterecieved Text, Sms text,ID INTEGER)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Student ( Account TEXT, Names TEXT, Class TEXT, Stream TEXT, Amount REAL, Dates TEXT, id INTEGER Not Null PRIMARY KEY AUTOINCREMENT UNIQUE, Years TEXT, Term TEXT )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query = "CREATE TABLE IF NOT EXISTS   Allacounts (Account Text, Phone text, ID INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =  "CREATE TABLE IF NOT EXISTS   Balances (Account Text,Names text, Class text,Stream text,Amount NUMERIC, ID INTEGER,Phone Text )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =  "CREATE TABLE IF NOT EXISTS   Balances2 (Account Text,Names text, Class text,Stream text,Amount REAL, ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	'query =   "CREATE VIEW Singlebal AS Select Balances.Amount FROM Balances INNER JOIN Allacounts ON Balances.Account = Allacounts.Account "
	'B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =   "CREATE TABLE IF NOT EXISTS   Eventsinfo (Events TEXT, Class TEXT,Stream TEXT, Dates TEXT,Tcode TEXT,	Id	INTEGER Not Null PRIMARY KEY AUTOINCREMENT UNIQUE,Term TEXT,Years TEXT)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =   "CREATE TABLE IF NOT EXISTS   Academics ( Names TEXT, Class TEXT, Stream TEXT, Subject TEXT, Total NUMERIC, Grade TEXT, Mid NUMERIC,Ends NUMERIC,Term TEXT, Years TEXT, id INTEGER,Phone TEXT )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =   "CREATE TABLE IF NOT EXISTS   Academicspast ( Names TEXT, Class TEXT, Stream TEXT, Subject TEXT, Total NUMERIC, Grade TEXT, Mid NUMERIC,Ends NUMERIC,Term TEXT, Years TEXT, id INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	'Expressed, sstscore, sstgrade, engscore, engrade, mathsscore, mathsgrade, sciencescore, sciencegrade, totalscore, totalgrade
			
	query =   "CREATE TABLE IF NOT EXISTS   Academicspastv2 ( Names TEXT, Class TEXT, Stream TEXT, Expressed TEXT, sstscore Text, sstgrade TEXT, engscore Text,engrade Text,mathsscore Text,mathsgrade Text,sciencescore Text,sciencegrade Text,Totalscore Text,Totalgrade TEXT,Division TEXT,ire Text,iregrade Text,Years Text,Admno Text, id INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =   "CREATE TABLE IF NOT EXISTS   Academicspastcurvev2 ( Names TEXT, Class TEXT, Stream TEXT, Expressed TEXT, sstscore Text, sstgrade TEXT, engscore Text,engrade Text,mathsscore Text,mathsgrade Text,sciencescore Text,sciencegrade Text,Totalscore Text,Totalgrade TEXT,Division TEXT,ire Text,iregrade Text,Years Text, id INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query =   "CREATE TABLE IF NOT EXISTS   Statement (Account Text,Names text,DESCRIPT text,DEBITAMNT text,CREDITAMNT text, TREF text,TRDATE nvarchar(50),BAL text)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	query = "CREATE TABLE IF NOT EXISTS   Studentphoto (Account Text,Names text, Class text,Stream text,image BLOB)"
	B4XPages.MainPage.SQL.ExecNonQuery(query)	
	
	query =   "CREATE TABLE IF NOT EXISTS   AcademicsLoadCurve ( Names TEXT, Class TEXT, Stream TEXT, Subject TEXT, Total NUMERIC, Grade TEXT, Mid NUMERIC,Ends NUMERIC,Term TEXT, Years TEXT, id INTEGER,Phone TEXT )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	
	query =   "CREATE TABLE IF NOT EXISTS   AcademicsLoadCurveP1P2 ( Names TEXT, Class TEXT, Stream TEXT, Subject TEXT, Total NUMERIC, Grade TEXT, Mid NUMERIC,Ends NUMERIC,Term TEXT, Years TEXT, id INTEGER,Phone TEXT )"		
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	'query =   "CREATE TABLE IF NOT EXISTS   AcademicsLoadCompare ( Names TEXT, Class TEXT, Stream TEXT, Subject TEXT, Total NUMERIC, Grade TEXT, Mid NUMERIC,Ends NUMERIC,Term TEXT, Years TEXT, id INTEGER,Phone TEXT )"
	'B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =   "CREATE TABLE IF NOT EXISTS    AcademicsLoadCurvePast( Names TEXT, Class TEXT, Stream TEXT, Expressed TEXT, sstscore Text, sstgrade TEXT, engscore Text,engrade Text,mathsscore Text,mathsgrade Text,sciencescore Text,sciencegrade Text,Totalscore Text,Totalgrade TEXT,Division TEXT,ire Text,iregrade Text,Years Text, id INTEGER )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	
	query =   "CREATE TABLE IF NOT EXISTS   AcademicsLoadCompare (Id INTEGER PRIMARY KEY, Names TEXT, admno TEXT, First TEXT, Subject TEXT, Second Text, Firsagg TEXT, Secagg Text,Differencemks Text,Differenceagg TEXT, Categorymks TEXT, Categoryagg TEXT )"
	B4XPages.MainPage.SQL.ExecNonQuery(query)
	CreateAndPopulateRegisterTable
End Sub

Sub CreateAndPopulateRegisterTable
	Dim strQuery As String = "CREATE TABLE IF NOT EXISTS  Register (Code Text, Phone Text, Email Text, Sex Text, ID INTEGER)"
	B4XPages.MainPage.SQL.ExecNonQuery(strQuery)
	Dim n As Int = B4XPages.MainPage.SQL.ExecQuerySingleResult("SELECT COUNT(*) FROM Register")
	If n = 0 Then
		'Comment the below line if you want 0 rec in register table. Uncomment if you want to have 1 rec in register table
	strQuery = $"INSERT INTO Register  VALUES(?, ?, ?, ?, ?)"$
		B4XPages.MainPage.SQL.ExecNonQuery2(strQuery, Array As Object("code1", "0782911364", "makumbi@ug.com", "Father", 1234))
	End If
End Sub


